diff -u -r nagios-cvs-20050405-old/base/nagios.c nagios-cvs-20050405/base/nagios.c
--- nagios-cvs-20050405-old/base/nagios.c	2005-04-04 05:52:39.000000000 +0200
+++ nagios-cvs-20050405/base/nagios.c	2005-04-05 10:07:43.000000000 +0200
@@ -430,6 +430,9 @@
 		/* clean up after ourselves */
 		cleanup();
 
+		/* free config_file */
+		free(config_file);
+
 		/* exit */
 		exit(result);
 	        }
@@ -736,7 +739,7 @@
 			cleanup();
 
 	                }while(sigrestart==TRUE && sigshutdown==FALSE);
-
+		
 		/* free misc memory */
 		free(config_file);
 	        }
diff -u -r nagios-cvs-20050405-old/base/nagiostats.c nagios-cvs-20050405/base/nagiostats.c
--- nagios-cvs-20050405-old/base/nagiostats.c	2005-04-04 05:52:39.000000000 +0200
+++ nagios-cvs-20050405/base/nagiostats.c	2005-04-05 10:07:43.000000000 +0200
@@ -50,6 +50,7 @@
 time_t program_start=0L;
 int status_service_entries=0;
 int status_host_entries=0;
+int enable_notifications=FALSE;
 
 double min_service_state_change=0.0;
 int have_min_service_state_change=FALSE;
@@ -526,6 +527,7 @@
 	time_difference=(current_time-program_start);
 	get_time_breakdown(time_difference,&days,&minutes,&hours,&seconds);
 	printf("Program Running Time:                 %dd %dh %dm %ds\n",days,hours,minutes,seconds);
+	printf("Notifications Enabled:                %d\n",enable_notifications);
 	printf("\n");
 	printf("Total Services:                       %d\n",status_service_entries);
 	printf("Services Checked:                     %d\n",services_checked);
@@ -899,6 +901,8 @@
 			case STATUS_PROGRAM_DATA:
 				if(!strcmp(var,"program_start"))
 					program_start=strtoul(val,NULL,10);
+				else if(!strcmp(var,"enable_notifications"))
+					enable_notifications=(atoi(val)>0)?TRUE:FALSE;
 				break;
 
 			case STATUS_HOST_DATA:
diff -u -r nagios-cvs-20050405-old/base/utils.c nagios-cvs-20050405/base/utils.c
--- nagios-cvs-20050405-old/base/utils.c	2005-03-25 01:04:19.000000000 +0100
+++ nagios-cvs-20050405/base/utils.c	2005-04-05 10:07:43.000000000 +0200
@@ -4316,8 +4316,10 @@
 		return NULL;
 
 	/* open the file */
-	if((fd=open(filename,mode))==-1)
+	if((fd=open(filename,mode))==-1) {
+		free(new_mmapfile);
 		return NULL;
+	}
 
 	/* get file info */
 	if((fstat(fd,&statbuf))==-1){
diff -u -r nagios-cvs-20050405-old/common/objects.c nagios-cvs-20050405/common/objects.c
--- nagios-cvs-20050405-old/common/objects.c	2004-11-30 18:16:23.000000000 +0100
+++ nagios-cvs-20050405/common/objects.c	2005-04-05 10:07:43.000000000 +0200
@@ -5743,6 +5743,7 @@
 		free(this_host->plugin_output);
 		free(this_host->perf_data);
 #endif
+		free(this_host->check_period);
 		free(this_host->host_check_command);
 		free(this_host->event_handler);
 		free(this_host->failure_prediction_options);
@@ -5827,6 +5828,9 @@
 		this_commandsmember=this_contact->host_notification_commands;
 		while(this_commandsmember!=NULL){
 			next_commandsmember=this_commandsmember->next;
+			if(this_commandsmember->command!=NULL){
+				free(this_commandsmember->command);
+			}
 			free(this_commandsmember);
 			this_commandsmember=next_commandsmember;
 		        }
@@ -5835,6 +5839,9 @@
 		this_commandsmember=this_contact->service_notification_commands;
 		while(this_commandsmember!=NULL){
 			next_commandsmember=this_commandsmember->next;
+			if(this_commandsmember->command!=NULL){
+				free(this_commandsmember->command);
+			}
 			free(this_commandsmember);
 			this_commandsmember=next_commandsmember;
 		        }
